
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 *
 ************************************************************************/

#include "asn_incl.h"
#include "apdu.h"

/*
 *    ir.c
 *
 *    "IR" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Wed May  4 14:15:20 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */

AsnLen
BEncAccessControlRespChoiceContent PARAMS((b, v),
BUF_TYPE b _AND_
AccessControlRespChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(ACCESSCONTROLRESPCHOICE_OLDWAY):
    itemLen = BEncAsnOctsContent( b, (v->a.oldway));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 38);

    totalLen += itemLen;

    break;

       case(ACCESSCONTROLRESPCHOICE_NEWWAY):
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncEXTERNALContent( b, (v->a.newway));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 8);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 0);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncAccessControlRespChoiceContent */

void
BDecAccessControlRespChoiceContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
AccessControlRespChoice* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, PRIM, 38)):
       case(MAKE_TAG_ID( CNTX, CONS, 38)):
        (v->choiceId) = ACCESSCONTROLRESPCHOICE_OLDWAY;
    (v->a.oldway) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    CheckAsn1Alloc((v->a.oldway), env);
    BDecAsnOctsContent( b, tagId0, elmtLen0, (v->a.oldway), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 0)):
if (BDecTag(b, &totalElmtsLen1, env) != MAKE_TAG_ID( UNIV, CONS, EXTERNAL_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -100);
    }

    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        (v->choiceId) = ACCESSCONTROLRESPCHOICE_NEWWAY;
    (v->a.newway) = (EXTERNAL*) Asn1Alloc(sizeof(EXTERNAL));
    CheckAsn1Alloc((v->a.newway), env);
    BDecEXTERNALContent( b, tagId1, elmtLen1, (v->a.newway), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -101);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecAccessControlRespChoiceContent */

void
PrintAccessControlRespChoice PARAMS((f, v, indent),
FILE* f _AND_
AccessControlRespChoice* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(ACCESSCONTROLRESPCHOICE_OLDWAY):
          fprintf(f,"oldway ");
    PrintAsnOcts(f, (v->a.oldway), indent + stdIndentG);
          break;

      case(ACCESSCONTROLRESPCHOICE_NEWWAY):
          fprintf(f,"newway ");
    PrintEXTERNAL(f, (v->a.newway), indent + stdIndentG);
          break;

    }
}  /* PrintAccessControlRespChoice */

void
FreeAccessControlRespChoice PARAMS((v),
AccessControlRespChoice* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
       case(ACCESSCONTROLRESPCHOICE_OLDWAY):
    FreeAsnOcts((v->a.oldway));
    Asn1Free((v->a.oldway));

    break;

       case(ACCESSCONTROLRESPCHOICE_NEWWAY):
    FreeEXTERNAL((v->a.newway));
    Asn1Free((v->a.newway));

    break;

    }
}  /* FreeAccessControlRespChoice */




AsnLen
BEncAccessControlReqChoiceContent PARAMS((b, v),
BUF_TYPE b _AND_
AccessControlReqChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(ACCESSCONTROLREQCHOICE_OLDWAY):
    itemLen = BEncAsnOctsContent( b, (v->a.oldway));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 37);

    totalLen += itemLen;

    break;

       case(ACCESSCONTROLREQCHOICE_NEWWAY):
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncEXTERNALContent( b, (v->a.newway));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 8);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 0);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncAccessControlReqChoiceContent */

void
BDecAccessControlReqChoiceContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
AccessControlReqChoice* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, PRIM, 37)):
       case(MAKE_TAG_ID( CNTX, CONS, 37)):
        (v->choiceId) = ACCESSCONTROLREQCHOICE_OLDWAY;
    (v->a.oldway) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    CheckAsn1Alloc((v->a.oldway), env);
    BDecAsnOctsContent( b, tagId0, elmtLen0, (v->a.oldway), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 0)):
if (BDecTag(b, &totalElmtsLen1, env) != MAKE_TAG_ID( UNIV, CONS, EXTERNAL_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -102);
    }

    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        (v->choiceId) = ACCESSCONTROLREQCHOICE_NEWWAY;
    (v->a.newway) = (EXTERNAL*) Asn1Alloc(sizeof(EXTERNAL));
    CheckAsn1Alloc((v->a.newway), env);
    BDecEXTERNALContent( b, tagId1, elmtLen1, (v->a.newway), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -103);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecAccessControlReqChoiceContent */

void
PrintAccessControlReqChoice PARAMS((f, v, indent),
FILE* f _AND_
AccessControlReqChoice* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(ACCESSCONTROLREQCHOICE_OLDWAY):
          fprintf(f,"oldway ");
    PrintAsnOcts(f, (v->a.oldway), indent + stdIndentG);
          break;

      case(ACCESSCONTROLREQCHOICE_NEWWAY):
          fprintf(f,"newway ");
    PrintEXTERNAL(f, (v->a.newway), indent + stdIndentG);
          break;

    }
}  /* PrintAccessControlReqChoice */

void
FreeAccessControlReqChoice PARAMS((v),
AccessControlReqChoice* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
       case(ACCESSCONTROLREQCHOICE_OLDWAY):
    FreeAsnOcts((v->a.oldway));
    Asn1Free((v->a.oldway));

    break;

       case(ACCESSCONTROLREQCHOICE_NEWWAY):
    FreeEXTERNAL((v->a.newway));
    Asn1Free((v->a.newway));

    break;

    }
}  /* FreeAccessControlReqChoice */




AsnLen BEncImplementationId PARAMS((b, v),
BUF_TYPE b _AND_
ImplementationId* v)
{
    AsnLen l;
    l = BEncImplementationIdContent(b, v);
    l += BEncDefLen(b, l);
    l += BEncTag2(b, CNTX, PRIM, 110);
    return(l);
} /* BEncImplementationId */

void BDecImplementationId PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
ImplementationId* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, PRIM, 110))&&
        (tag != MAKE_TAG_ID(CNTX, CONS, 110)))
    {
        Asn1Error("BDecImplementationId: ERROR - wrong tag\n");
        longjmp(env, -104);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecImplementationIdContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecImplementationId */

AsnLen BEncImplementationName PARAMS((b, v),
BUF_TYPE b _AND_
ImplementationName* v)
{
    AsnLen l;
    l = BEncImplementationNameContent(b, v);
    l += BEncDefLen(b, l);
    l += BEncTag2(b, CNTX, PRIM, 111);
    return(l);
} /* BEncImplementationName */

void BDecImplementationName PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
ImplementationName* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, PRIM, 111))&&
        (tag != MAKE_TAG_ID(CNTX, CONS, 111)))
    {
        Asn1Error("BDecImplementationName: ERROR - wrong tag\n");
        longjmp(env, -105);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecImplementationNameContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecImplementationName */

AsnLen BEncImplementationVersion PARAMS((b, v),
BUF_TYPE b _AND_
ImplementationVersion* v)
{
    AsnLen l;
    l = BEncImplementationVersionContent(b, v);
    l += BEncDefLen(b, l);
    l += BEncTag2(b, CNTX, PRIM, 112);
    return(l);
} /* BEncImplementationVersion */

void BDecImplementationVersion PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
ImplementationVersion* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, PRIM, 112))&&
        (tag != MAKE_TAG_ID(CNTX, CONS, 112)))
    {
        Asn1Error("BDecImplementationVersion: ERROR - wrong tag\n");
        longjmp(env, -106);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecImplementationVersionContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecImplementationVersion */

AsnLen BEncUserInfoField PARAMS((b, v),
BUF_TYPE b _AND_
UserInfoField* v)
{
    AsnLen l;
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    l = BEncUserInfoFieldContent(b, v);
    l += BEncConsLen(b, l);
    l += BEncTag1(b, UNIV, CONS, EXTERNAL_TAG_CODE);
    l += BEncConsLen(b, l);
    l += BEncTag1(b, CNTX, CONS, 11);
    return(l);
} /* BEncUserInfoField */

void BDecUserInfoField PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
UserInfoField* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;
    AsnLen elmtLen2;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, CONS, 11)))
    {
        Asn1Error("BDecUserInfoField: ERROR - wrong tag\n");
        longjmp(env, -107);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, CONS, EXTERNAL_TAG_CODE)))
    {
        Asn1Error("BDecUserInfoField: ERROR - wrong tag\n");
        longjmp(env, -108);
    }
    elmtLen2 = BDecLen(b, bytesDecoded, env);
    BDecUserInfoFieldContent(b, tag, elmtLen2, result, bytesDecoded, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, bytesDecoded, env);
}  /* BDecUserInfoField */

AsnLen
BEncOperatorContent PARAMS((b, v),
BUF_TYPE b _AND_
Operator* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(OPERATOR_AND):
    itemLen = BEncAsnNullContent( b, (&v->a.and));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 0);

    totalLen += itemLen;

    break;

       case(OPERATOR_OR):
    itemLen = BEncAsnNullContent( b, (&v->a.or));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 1);

    totalLen += itemLen;

    break;

       case(OPERATOR_AND_NOT):
    itemLen = BEncAsnNullContent( b, (&v->a.and_not));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncOperatorContent */

void
BDecOperatorContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
Operator* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, PRIM, 0)):
        (v->choiceId) = OPERATOR_AND;
    BDecAsnNullContent( b, tagId0, elmtLen0, (&v->a.and), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, PRIM, 1)):
        (v->choiceId) = OPERATOR_OR;
    BDecAsnNullContent( b, tagId0, elmtLen0, (&v->a.or), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, PRIM, 2)):
        (v->choiceId) = OPERATOR_AND_NOT;
    BDecAsnNullContent( b, tagId0, elmtLen0, (&v->a.and_not), &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -109);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecOperatorContent */

void
PrintOperator PARAMS((f, v, indent),
FILE* f _AND_
Operator* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(OPERATOR_AND):
          fprintf(f,"and ");
    PrintAsnNull(f, (&v->a.and), indent + stdIndentG);
          break;

      case(OPERATOR_OR):
          fprintf(f,"or ");
    PrintAsnNull(f, (&v->a.or), indent + stdIndentG);
          break;

      case(OPERATOR_AND_NOT):
          fprintf(f,"and-not ");
    PrintAsnNull(f, (&v->a.and_not), indent + stdIndentG);
          break;

    }
}  /* PrintOperator */

void
FreeOperator PARAMS((v),
Operator* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
    }
}  /* FreeOperator */




AsnLen
BEncDiagRecContent PARAMS((b, v),
BUF_TYPE b _AND_
DiagRec* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = BEncVisibleStringContent( b, (&v->addInfo));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, PRIM, 26);

    totalLen += itemLen;

    itemLen = BEncAsnIntContent( b, (&v->condition));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, UNIV, PRIM, 2);

    totalLen += itemLen;

    itemLen = BEncAsnOidContent( b, (&v->diagnosticSetId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, PRIM, 6);

    totalLen += itemLen;

    return (totalLen);

}  /* BEncDiagRecContent */

void
BDecDiagRecContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
DiagRec* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( UNIV, PRIM, OID_TAG_CODE))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnOidContent( b, tagId1, elmtLen1, (&v->diagnosticSetId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -110);


    if ((( tagId1 == MAKE_TAG_ID( UNIV, PRIM, INTEGER_TAG_CODE))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnIntContent( b, tagId1, elmtLen1, (&v->condition), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -111);


    if ((( tagId1 == MAKE_TAG_ID( UNIV, PRIM, VISIBLESTRING_TAG_CODE)) ||
( tagId1 == MAKE_TAG_ID( UNIV, CONS, VISIBLESTRING_TAG_CODE))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecVisibleStringContent( b, tagId1, elmtLen1, (&v->addInfo), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -112);
    }
    else
        longjmp(env, -113);


    if (!seqDone)
        longjmp(env, -114);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecDiagRecContent */

void
PrintDiagRec PARAMS((f, v, indent),
FILE* f _AND_
DiagRec* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    fprintf(f,"diagnosticSetId ");
    PrintAsnOid(f, (&v->diagnosticSetId), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"condition ");
    PrintAsnInt(f, (&v->condition), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"addInfo ");
    PrintVisibleString(f, (&v->addInfo), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintDiagRec */

void
FreeDiagRec PARAMS((v),
DiagRec* v)
{

    if (v == NULL)
        return;
    FreeAsnOid((&v->diagnosticSetId));

    FreeAsnInt((&v->condition));

    FreeVisibleString((&v->addInfo));

}  /* FreeDiagRec */




AsnLen BEncElementSetName PARAMS((b, v),
BUF_TYPE b _AND_
ElementSetName* v)
{
    AsnLen l;
    l = BEncElementSetNameContent(b, v);
    l += BEncDefLen(b, l);
    l += BEncTag2(b, CNTX, PRIM, 103);
    return(l);
} /* BEncElementSetName */

void BDecElementSetName PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
ElementSetName* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, PRIM, 103))&&
        (tag != MAKE_TAG_ID(CNTX, CONS, 103)))
    {
        Asn1Error("BDecElementSetName: ERROR - wrong tag\n");
        longjmp(env, -115);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecElementSetNameContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecElementSetName */

AsnLen BEncDatabaseName PARAMS((b, v),
BUF_TYPE b _AND_
DatabaseName* v)
{
    AsnLen l;
    l = BEncDatabaseNameContent(b, v);
    l += BEncDefLen(b, l);
    l += BEncTag2(b, CNTX, PRIM, 105);
    return(l);
} /* BEncDatabaseName */

void BDecDatabaseName PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
DatabaseName* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, PRIM, 105))&&
        (tag != MAKE_TAG_ID(CNTX, CONS, 105)))
    {
        Asn1Error("BDecDatabaseName: ERROR - wrong tag\n");
        longjmp(env, -116);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecDatabaseNameContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecDatabaseName */

AsnLen BEncResultSetId PARAMS((b, v),
BUF_TYPE b _AND_
ResultSetId* v)
{
    AsnLen l;
    l = BEncResultSetIdContent(b, v);
    l += BEncDefLen(b, l);
    l += BEncTag2(b, CNTX, PRIM, 31);
    return(l);
} /* BEncResultSetId */

void BDecResultSetId PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
ResultSetId* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(CNTX, PRIM, 31))&&
        (tag != MAKE_TAG_ID(CNTX, CONS, 31)))
    {
        Asn1Error("BDecResultSetId: ERROR - wrong tag\n");
        longjmp(env, -117);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecResultSetIdContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecResultSetId */

AsnLen
BEncListStatusesSeqContent PARAMS((b, v),
BUF_TYPE b _AND_
ListStatusesSeq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = BEncDeleteSetStatusContent( b, (&v->deleteSetStatus));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 33);

    totalLen += itemLen;

    itemLen = BEncResultSetIdContent( b, (&v->resultSetId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 31);

    totalLen += itemLen;

    return (totalLen);

}  /* BEncListStatusesSeqContent */

void
BDecListStatusesSeqContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ListStatusesSeq* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 31)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 31))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecResultSetIdContent( b, tagId1, elmtLen1, (&v->resultSetId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -118);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 33))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecDeleteSetStatusContent( b, tagId1, elmtLen1, (&v->deleteSetStatus), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -119);
    }
    else
        longjmp(env, -120);


    if (!seqDone)
        longjmp(env, -121);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecListStatusesSeqContent */

void
PrintListStatusesSeq PARAMS((f, v, indent),
FILE* f _AND_
ListStatusesSeq* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    PrintResultSetId(f, (&v->resultSetId), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    PrintDeleteSetStatus(f, (&v->deleteSetStatus), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintListStatusesSeq */

void
FreeListStatusesSeq PARAMS((v),
ListStatusesSeq* v)
{

    if (v == NULL)
        return;
    FreeResultSetId((&v->resultSetId));

    FreeDeleteSetStatus((&v->deleteSetStatus));

}  /* FreeListStatusesSeq */




AsnLen
BEncDeleteResultSetReqSeqOfContent PARAMS((b, v),
BUF_TYPE b _AND_
DeleteResultSetReqSeqOf* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

        listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    itemLen = BEncResultSetIdContent( b, component);
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 31);

        listLen += itemLen;
    }
    return (listLen);

}  /* BEncDeleteResultSetReqSeqOfContent */

void
BDecDeleteResultSetReqSeqOfContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
DeleteResultSetReqSeqOf* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    for ( totalElmtsLen1 = 0; (totalElmtsLen1 < elmtLen0) || (elmtLen0 == INDEFINITE_LEN);)
    {
        ResultSetId** tmpVar;
    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ( (tagId1 == EOC_TAG_ID) && (elmtLen0 == INDEFINITE_LEN))
    {
        BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
        break; /* got EOC so can exit this SET OF/SEQ OF's for loop*/
    }
    if ( (tagId1 == MAKE_TAG_ID( CNTX, PRIM, 31)) ||
       (tagId1 == MAKE_TAG_ID( CNTX, CONS, 31)))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    tmpVar = (ResultSetId**) AsnListAppend(v);
    (*tmpVar) = (ResultSetId*) Asn1Alloc(sizeof(ResultSetId));
    CheckAsn1Alloc((*tmpVar), env);
    BDecResultSetIdContent( b, tagId1, elmtLen1, (*tmpVar), &totalElmtsLen1, env);
    }  /* end of tag check if */
    else  /* wrong tag */
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -122);
    }
    } /* end of for */

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecDeleteResultSetReqSeqOfContent */

void
PrintDeleteResultSetReqSeqOf PARAMS((f, v, indent),
FILE* f _AND_
DeleteResultSetReqSeqOf* v _AND_
unsigned short int indent)
{
    ResultSetId* tmp;
    if (v == NULL)
        return;
    fprintf(f,"{ -- SEQUENCE OF -- \n");
    FOR_EACH_LIST_ELMT(tmp, v)
    {
        Indent(f, indent+ stdIndentG);
        PrintResultSetId(f, tmp, indent + stdIndentG);
        if (tmp != (ResultSetId*)LAST_LIST_ELMT(v))
            fprintf(f,",\n");
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintDeleteResultSetReqSeqOf */

void
FreeDeleteResultSetReqSeqOf PARAMS((v),
DeleteResultSetReqSeqOf* v)
{

    AsnListNode* l;
    AsnListNode* tmp;
    if (v == NULL)
        return;
    for (l = FIRST_LIST_NODE(v); l != NULL; )
    {
        FreeResultSetId((l->data));
        tmp = l->next;
        Asn1Free(l->data);
        Asn1Free(l);
        l = tmp;
    }
}  /* FreeDeleteResultSetReqSeqOf */




AsnLen
BEncElementSetNamesSeqOfSeqContent PARAMS((b, v),
BUF_TYPE b _AND_
ElementSetNamesSeqOfSeq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = BEncElementSetNameContent( b, (&v->elementSetName));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 103);

    totalLen += itemLen;

    itemLen = BEncDatabaseNameContent( b, (&v->databaseName));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 105);

    totalLen += itemLen;

    return (totalLen);

}  /* BEncElementSetNamesSeqOfSeqContent */

void
BDecElementSetNamesSeqOfSeqContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ElementSetNamesSeqOfSeq* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 105)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 105))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecDatabaseNameContent( b, tagId1, elmtLen1, (&v->databaseName), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -123);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 103)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 103))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecElementSetNameContent( b, tagId1, elmtLen1, (&v->elementSetName), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -124);
    }
    else
        longjmp(env, -125);


    if (!seqDone)
        longjmp(env, -126);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecElementSetNamesSeqOfSeqContent */

void
PrintElementSetNamesSeqOfSeq PARAMS((f, v, indent),
FILE* f _AND_
ElementSetNamesSeqOfSeq* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    PrintDatabaseName(f, (&v->databaseName), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    PrintElementSetName(f, (&v->elementSetName), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintElementSetNamesSeqOfSeq */

void
FreeElementSetNamesSeqOfSeq PARAMS((v),
ElementSetNamesSeqOfSeq* v)
{

    if (v == NULL)
        return;
    FreeDatabaseName((&v->databaseName));

    FreeElementSetName((&v->elementSetName));

}  /* FreeElementSetNamesSeqOfSeq */




AsnLen
BEncElementSetNamesSeqOfContent PARAMS((b, v),
BUF_TYPE b _AND_
ElementSetNamesSeqOf* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

        listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    BEncEocIfNec(b);
    itemLen = BEncElementSetNamesSeqOfSeqContent( b, component);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 16);

        listLen += itemLen;
    }
    return (listLen);

}  /* BEncElementSetNamesSeqOfContent */

void
BDecElementSetNamesSeqOfContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ElementSetNamesSeqOf* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    for ( totalElmtsLen1 = 0; (totalElmtsLen1 < elmtLen0) || (elmtLen0 == INDEFINITE_LEN);)
    {
        ElementSetNamesSeqOfSeq** tmpVar;
    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ( (tagId1 == EOC_TAG_ID) && (elmtLen0 == INDEFINITE_LEN))
    {
        BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
        break; /* got EOC so can exit this SET OF/SEQ OF's for loop*/
    }
    if ( (tagId1 == MAKE_TAG_ID( UNIV, CONS, SEQ_TAG_CODE)))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    tmpVar = (ElementSetNamesSeqOfSeq**) AsnListAppend(v);
    (*tmpVar) = (ElementSetNamesSeqOfSeq*) Asn1Alloc(sizeof(ElementSetNamesSeqOfSeq));
    CheckAsn1Alloc((*tmpVar), env);
    BDecElementSetNamesSeqOfSeqContent( b, tagId1, elmtLen1, (*tmpVar), &totalElmtsLen1, env);
    }  /* end of tag check if */
    else  /* wrong tag */
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -127);
    }
    } /* end of for */

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecElementSetNamesSeqOfContent */

void
PrintElementSetNamesSeqOf PARAMS((f, v, indent),
FILE* f _AND_
ElementSetNamesSeqOf* v _AND_
unsigned short int indent)
{
    ElementSetNamesSeqOfSeq* tmp;
    if (v == NULL)
        return;
    fprintf(f,"{ -- SEQUENCE OF -- \n");
    FOR_EACH_LIST_ELMT(tmp, v)
    {
        Indent(f, indent+ stdIndentG);
        PrintElementSetNamesSeqOfSeq(f, tmp, indent + stdIndentG);
        if (tmp != (ElementSetNamesSeqOfSeq*)LAST_LIST_ELMT(v))
            fprintf(f,",\n");
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintElementSetNamesSeqOf */

void
FreeElementSetNamesSeqOf PARAMS((v),
ElementSetNamesSeqOf* v)
{

    AsnListNode* l;
    AsnListNode* tmp;
    if (v == NULL)
        return;
    for (l = FIRST_LIST_NODE(v); l != NULL; )
    {
        FreeElementSetNamesSeqOfSeq((l->data));
        tmp = l->next;
        Asn1Free(l->data);
        Asn1Free(l);
        l = tmp;
    }
}  /* FreeElementSetNamesSeqOf */




AsnLen
BEncNamePlusRecordChoiceContent PARAMS((b, v),
BUF_TYPE b _AND_
NamePlusRecordChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(NAMEPLUSRECORDCHOICE_DATABASERECORD):
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncDatabaseRecordContent( b, (v->a.databaseRecord));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 8);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 1);

    totalLen += itemLen;

    break;

       case(NAMEPLUSRECORDCHOICE_SURROGATEDIAGNOSTIC):
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncDiagRecContent( b, (v->a.surrogateDiagnostic));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 16);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 2);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncNamePlusRecordChoiceContent */

void
BDecNamePlusRecordChoiceContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
NamePlusRecordChoice* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, CONS, 1)):
if (BDecTag(b, &totalElmtsLen1, env) != MAKE_TAG_ID( UNIV, CONS, EXTERNAL_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -128);
    }

    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        (v->choiceId) = NAMEPLUSRECORDCHOICE_DATABASERECORD;
    (v->a.databaseRecord) = (DatabaseRecord*) Asn1Alloc(sizeof(DatabaseRecord));
    CheckAsn1Alloc((v->a.databaseRecord), env);
    BDecDatabaseRecordContent( b, tagId1, elmtLen1, (v->a.databaseRecord), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 2)):
if (BDecTag(b, &totalElmtsLen1, env) != MAKE_TAG_ID( UNIV, CONS, SEQ_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -129);
    }

    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        (v->choiceId) = NAMEPLUSRECORDCHOICE_SURROGATEDIAGNOSTIC;
    (v->a.surrogateDiagnostic) = (DiagRec*) Asn1Alloc(sizeof(DiagRec));
    CheckAsn1Alloc((v->a.surrogateDiagnostic), env);
    BDecDiagRecContent( b, tagId1, elmtLen1, (v->a.surrogateDiagnostic), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -130);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecNamePlusRecordChoiceContent */

void
PrintNamePlusRecordChoice PARAMS((f, v, indent),
FILE* f _AND_
NamePlusRecordChoice* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(NAMEPLUSRECORDCHOICE_DATABASERECORD):
          fprintf(f,"databaseRecord ");
    PrintDatabaseRecord(f, (v->a.databaseRecord), indent + stdIndentG);
          break;

      case(NAMEPLUSRECORDCHOICE_SURROGATEDIAGNOSTIC):
          fprintf(f,"surrogateDiagnostic ");
    PrintDiagRec(f, (v->a.surrogateDiagnostic), indent + stdIndentG);
          break;

    }
}  /* PrintNamePlusRecordChoice */

void
FreeNamePlusRecordChoice PARAMS((v),
NamePlusRecordChoice* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
       case(NAMEPLUSRECORDCHOICE_DATABASERECORD):
    FreeDatabaseRecord((v->a.databaseRecord));
    Asn1Free((v->a.databaseRecord));

    break;

       case(NAMEPLUSRECORDCHOICE_SURROGATEDIAGNOSTIC):
    FreeDiagRec((v->a.surrogateDiagnostic));
    Asn1Free((v->a.surrogateDiagnostic));

    break;

    }
}  /* FreeNamePlusRecordChoice */




AsnLen
BEncSearchReqSeqOfContent PARAMS((b, v),
BUF_TYPE b _AND_
SearchReqSeqOf* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

        listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    itemLen = BEncDatabaseNameContent( b, component);
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 105);

        listLen += itemLen;
    }
    return (listLen);

}  /* BEncSearchReqSeqOfContent */

void
BDecSearchReqSeqOfContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
SearchReqSeqOf* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    for ( totalElmtsLen1 = 0; (totalElmtsLen1 < elmtLen0) || (elmtLen0 == INDEFINITE_LEN);)
    {
        DatabaseName** tmpVar;
    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ( (tagId1 == EOC_TAG_ID) && (elmtLen0 == INDEFINITE_LEN))
    {
        BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
        break; /* got EOC so can exit this SET OF/SEQ OF's for loop*/
    }
    if ( (tagId1 == MAKE_TAG_ID( CNTX, PRIM, 105)) ||
       (tagId1 == MAKE_TAG_ID( CNTX, CONS, 105)))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    tmpVar = (DatabaseName**) AsnListAppend(v);
    (*tmpVar) = (DatabaseName*) Asn1Alloc(sizeof(DatabaseName));
    CheckAsn1Alloc((*tmpVar), env);
    BDecDatabaseNameContent( b, tagId1, elmtLen1, (*tmpVar), &totalElmtsLen1, env);
    }  /* end of tag check if */
    else  /* wrong tag */
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -131);
    }
    } /* end of for */

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecSearchReqSeqOfContent */

void
PrintSearchReqSeqOf PARAMS((f, v, indent),
FILE* f _AND_
SearchReqSeqOf* v _AND_
unsigned short int indent)
{
    DatabaseName* tmp;
    if (v == NULL)
        return;
    fprintf(f,"{ -- SEQUENCE OF -- \n");
    FOR_EACH_LIST_ELMT(tmp, v)
    {
        Indent(f, indent+ stdIndentG);
        PrintDatabaseName(f, tmp, indent + stdIndentG);
        if (tmp != (DatabaseName*)LAST_LIST_ELMT(v))
            fprintf(f,",\n");
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintSearchReqSeqOf */

void
FreeSearchReqSeqOf PARAMS((v),
SearchReqSeqOf* v)
{

    AsnListNode* l;
    AsnListNode* tmp;
    if (v == NULL)
        return;
    for (l = FIRST_LIST_NODE(v); l != NULL; )
    {
        FreeDatabaseName((l->data));
        tmp = l->next;
        Asn1Free(l->data);
        Asn1Free(l);
        l = tmp;
    }
}  /* FreeSearchReqSeqOf */




AsnLen
BEncInitializeReqContent PARAMS((b, v),
BUF_TYPE b _AND_
InitializeReq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (NOT_NULL((v->userInfoField)))
    {
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncUserInfoFieldContent( b, (v->userInfoField));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 8);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 11);

    totalLen += itemLen;
    }

    if (ASNOCTS_PRESENT((&v->implementationVersion)))
    {
    itemLen = BEncImplementationVersionContent( b, (&v->implementationVersion));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 112);

    totalLen += itemLen;
    }

    if (ASNOCTS_PRESENT((&v->implementationName)))
    {
    itemLen = BEncImplementationNameContent( b, (&v->implementationName));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 111);

    totalLen += itemLen;
    }

    if (ASNOCTS_PRESENT((&v->implementationId)))
    {
    itemLen = BEncImplementationIdContent( b, (&v->implementationId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 110);

    totalLen += itemLen;
    }

    if (ASNOCTS_PRESENT((&v->idAuthentication)))
    {
    BEncEocIfNec(b);
    itemLen = BEncVisibleStringContent( b, (&v->idAuthentication));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, PRIM, 26);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 7);

    totalLen += itemLen;
    }

    itemLen = BEncMaximumRecordSizeContent( b, (&v->maximumRecordSize));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 6);

    totalLen += itemLen;

    itemLen = BEncPreferredMessageSizeContent( b, (&v->preferredMessageSize));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 5);

    totalLen += itemLen;

    itemLen = BEncOptionsContent( b, (&v->options));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 4);

    totalLen += itemLen;

    itemLen = BEncProtocolVersionContent( b, (&v->protocolVersion));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 3);

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncInitializeReqContent */

