
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 *
 ************************************************************************/

#include "asn_incl.h"
#include "apdu.h"

/*
 *    ir.c
 *
 *    "IR" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Wed May  4 14:15:20 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */

void
FreeAccessControlReq PARAMS((v),
AccessControlReq* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    FreeAccessControlReqChoice((v->securityChallenge));
    Asn1Free((v->securityChallenge));

}  /* FreeAccessControlReq */




AsnLen
BEncAccessControlRespContent PARAMS((b, v),
BUF_TYPE b _AND_
AccessControlResp* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = BEncAccessControlRespChoiceContent( b, (v->securityChallengeResponse));

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncAccessControlRespContent */

void
BDecAccessControlRespContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
AccessControlResp* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 38)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 38)) ||
    ( tagId1 == MAKE_TAG_ID( CNTX, CONS, 0))))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->securityChallengeResponse) = (AccessControlRespChoice*) Asn1Alloc(sizeof(AccessControlRespChoice));
    CheckAsn1Alloc((v->securityChallengeResponse), env);
    BDecAccessControlRespChoiceContent( b, tagId1, elmtLen1, (v->securityChallengeResponse), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -163);
    }
    else
        longjmp(env, -164);


    if (!seqDone)
        longjmp(env, -165);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecAccessControlRespContent */

void
PrintAccessControlResp PARAMS((f, v, indent),
FILE* f _AND_
AccessControlResp* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"securityChallengeResponse ");
    PrintAccessControlRespChoice(f, (v->securityChallengeResponse), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintAccessControlResp */

void
FreeAccessControlResp PARAMS((v),
AccessControlResp* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    FreeAccessControlRespChoice((v->securityChallengeResponse));
    Asn1Free((v->securityChallengeResponse));

}  /* FreeAccessControlResp */




AsnLen
BEncResourceControlReqContent PARAMS((b, v),
BUF_TYPE b _AND_
ResourceControlReq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (NOT_NULL((v->triggeredRequestFlag)))
    {
    itemLen = BEncAsnBoolContent( b, (v->triggeredRequestFlag));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 43);

    totalLen += itemLen;
    }

    itemLen = BEncAsnBoolContent( b, (&v->responseRequired));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 42);

    totalLen += itemLen;

    if (NOT_NULL((v->partialResultsAvailable)))
    {
    itemLen = BEncResourceControlReqIntContent( b, (v->partialResultsAvailable));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 41);

    totalLen += itemLen;
    }

    if (NOT_NULL((v->resourceReport)))
    {
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncResourceReportContent( b, (v->resourceReport));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 8);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 40);

    totalLen += itemLen;
    }

    if (NOT_NULL((v->suspendedFlag)))
    {
    itemLen = BEncAsnBoolContent( b, (v->suspendedFlag));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 39);

    totalLen += itemLen;
    }

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncResourceControlReqContent */

void
BDecResourceControlReqContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ResourceControlReq* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 39))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->suspendedFlag) = (AsnBool*) Asn1Alloc(sizeof(AsnBool));
    CheckAsn1Alloc((v->suspendedFlag), env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (v->suspendedFlag), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 40))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        tagId2 = BDecTag(b, &totalElmtsLen1, env);

    if ( tagId2 != MAKE_TAG_ID( UNIV, CONS, EXTERNAL_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -166);
    }

    elmtLen2 = BDecLen (b, &totalElmtsLen1, env);
    (v->resourceReport) = (ResourceReport*) Asn1Alloc(sizeof(ResourceReport));
    CheckAsn1Alloc((v->resourceReport), env);
    BDecResourceReportContent( b, tagId2, elmtLen2, (v->resourceReport), &totalElmtsLen1, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 41))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->partialResultsAvailable) = (ResourceControlReqInt*) Asn1Alloc(sizeof(ResourceControlReqInt));
    CheckAsn1Alloc((v->partialResultsAvailable), env);
    BDecResourceControlReqIntContent( b, tagId1, elmtLen1, (v->partialResultsAvailable), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 42))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (&v->responseRequired), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }
    else
        longjmp(env, -167);


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 43))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->triggeredRequestFlag) = (AsnBool*) Asn1Alloc(sizeof(AsnBool));
    CheckAsn1Alloc((v->triggeredRequestFlag), env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (v->triggeredRequestFlag), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -168);
    }


    if (!seqDone)
        longjmp(env, -169);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecResourceControlReqContent */

void
PrintResourceControlReq PARAMS((f, v, indent),
FILE* f _AND_
ResourceControlReq* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    if ( NOT_NULL((v->suspendedFlag)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"suspendedFlag ");
    PrintAsnBool(f, (v->suspendedFlag), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    if ( NOT_NULL((v->resourceReport)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"resourceReport ");
    PrintResourceReport(f, (v->resourceReport), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    if ( NOT_NULL((v->partialResultsAvailable)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"partialResultsAvailable ");
    PrintResourceControlReqInt(f, (v->partialResultsAvailable), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"responseRequired ");
    PrintAsnBool(f, (&v->responseRequired), indent + stdIndentG);
    if ( NOT_NULL((v->triggeredRequestFlag)))
    {
    fprintf(f,",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"triggeredRequestFlag ");
    PrintAsnBool(f, (v->triggeredRequestFlag), indent + stdIndentG);
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintResourceControlReq */

void
FreeResourceControlReq PARAMS((v),
ResourceControlReq* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    if ( NOT_NULL((v->suspendedFlag)))
    {
    FreeAsnBool((v->suspendedFlag));
    Asn1Free((v->suspendedFlag));
    }

    if ( NOT_NULL((v->resourceReport)))
    {
    FreeResourceReport((v->resourceReport));
    Asn1Free((v->resourceReport));
    }

    if ( NOT_NULL((v->partialResultsAvailable)))
    {
    FreeResourceControlReqInt((v->partialResultsAvailable));
    Asn1Free((v->partialResultsAvailable));
    }

    FreeAsnBool((&v->responseRequired));

    if ( NOT_NULL((v->triggeredRequestFlag)))
    {
    FreeAsnBool((v->triggeredRequestFlag));
    Asn1Free((v->triggeredRequestFlag));
    }

}  /* FreeResourceControlReq */




AsnLen
BEncResourceControlRespContent PARAMS((b, v),
BUF_TYPE b _AND_
ResourceControlResp* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (NOT_NULL((v->resultSetWanted)))
    {
    itemLen = BEncAsnBoolContent( b, (v->resultSetWanted));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 45);

    totalLen += itemLen;
    }

    itemLen = BEncAsnBoolContent( b, (&v->continueFlag));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 44);

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncResourceControlRespContent */

void
BDecResourceControlRespContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ResourceControlResp* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 44))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (&v->continueFlag), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }
    else
        longjmp(env, -170);


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 45))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->resultSetWanted) = (AsnBool*) Asn1Alloc(sizeof(AsnBool));
    CheckAsn1Alloc((v->resultSetWanted), env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (v->resultSetWanted), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -171);
    }


    if (!seqDone)
        longjmp(env, -172);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecResourceControlRespContent */

void
PrintResourceControlResp PARAMS((f, v, indent),
FILE* f _AND_
ResourceControlResp* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"continueFlag ");
    PrintAsnBool(f, (&v->continueFlag), indent + stdIndentG);
    if ( NOT_NULL((v->resultSetWanted)))
    {
    fprintf(f,",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"resultSetWanted ");
    PrintAsnBool(f, (v->resultSetWanted), indent + stdIndentG);
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintResourceControlResp */

void
FreeResourceControlResp PARAMS((v),
ResourceControlResp* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    FreeAsnBool((&v->continueFlag));

    if ( NOT_NULL((v->resultSetWanted)))
    {
    FreeAsnBool((v->resultSetWanted));
    Asn1Free((v->resultSetWanted));
    }

}  /* FreeResourceControlResp */




AsnLen
BEncTriggerResourceReqContent PARAMS((b, v),
BUF_TYPE b _AND_
TriggerResourceReq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (NOT_NULL((v->resultSetWanted)))
    {
    itemLen = BEncAsnBoolContent( b, (v->resultSetWanted));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 48);

    totalLen += itemLen;
    }

    if (ASNOID_PRESENT((&v->preferredRsrcRprtFmt)))
    {
    itemLen = BEncResourceReportIdContent( b, (&v->preferredRsrcRprtFmt));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 47);

    totalLen += itemLen;
    }

    itemLen = BEncTriggerResourceReqIntContent( b, (&v->requestedOperation));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 46);

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncTriggerResourceReqContent */

void
BDecTriggerResourceReqContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
TriggerResourceReq* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 46))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecTriggerResourceReqIntContent( b, tagId1, elmtLen1, (&v->requestedOperation), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }
    else
        longjmp(env, -173);


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 47))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecResourceReportIdContent( b, tagId1, elmtLen1, (&v->preferredRsrcRprtFmt), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 48))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->resultSetWanted) = (AsnBool*) Asn1Alloc(sizeof(AsnBool));
    CheckAsn1Alloc((v->resultSetWanted), env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (v->resultSetWanted), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -174);
    }


    if (!seqDone)
        longjmp(env, -175);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecTriggerResourceReqContent */

void
PrintTriggerResourceReq PARAMS((f, v, indent),
FILE* f _AND_
TriggerResourceReq* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"requestedOperation ");
    PrintTriggerResourceReqInt(f, (&v->requestedOperation), indent + stdIndentG);
    if ( ASNOID_PRESENT((&v->preferredRsrcRprtFmt)))
    {
    fprintf(f,",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"preferredRsrcRprtFmt ");
    PrintResourceReportId(f, (&v->preferredRsrcRprtFmt), indent + stdIndentG);
    }
    if ( NOT_NULL((v->resultSetWanted)))
    {
    fprintf(f,",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"resultSetWanted ");
    PrintAsnBool(f, (v->resultSetWanted), indent + stdIndentG);
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintTriggerResourceReq */

void
FreeTriggerResourceReq PARAMS((v),
TriggerResourceReq* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    FreeTriggerResourceReqInt((&v->requestedOperation));

    if ( ASNOID_PRESENT((&v->preferredRsrcRprtFmt)))
    {
    FreeResourceReportId((&v->preferredRsrcRprtFmt));
    }

    if ( NOT_NULL((v->resultSetWanted)))
    {
    FreeAsnBool((v->resultSetWanted));
    Asn1Free((v->resultSetWanted));
    }

}  /* FreeTriggerResourceReq */




AsnLen
BEncResourceReportReqContent PARAMS((b, v),
BUF_TYPE b _AND_
ResourceReportReq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (ASNOID_PRESENT((&v->preferredRsrcRprtFmt)))
    {
    itemLen = BEncResourceReportIdContent( b, (&v->preferredRsrcRprtFmt));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 49);

    totalLen += itemLen;
    }

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncResourceReportReqContent */

void
BDecResourceReportReqContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ResourceReportReq* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }

    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 49))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecResourceReportIdContent( b, tagId1, elmtLen1, (&v->preferredRsrcRprtFmt), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -176);
    }


    if (!seqDone)
        longjmp(env, -177);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecResourceReportReqContent */

void
PrintResourceReportReq PARAMS((f, v, indent),
FILE* f _AND_
ResourceReportReq* v _AND_
unsigned short int indent)
{
    int nonePrinted = TRUE;

    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    nonePrinted = FALSE;
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    }
    if ( ASNOID_PRESENT((&v->preferredRsrcRprtFmt)))
    {
    if (!nonePrinted)
        fprintf(f,",\n");
    nonePrinted = FALSE;
    Indent(f, indent + stdIndentG);
    fprintf(f,"preferredRsrcRprtFmt ");
    PrintResourceReportId(f, (&v->preferredRsrcRprtFmt), indent + stdIndentG);
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintResourceReportReq */

void
FreeResourceReportReq PARAMS((v),
ResourceReportReq* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    if ( ASNOID_PRESENT((&v->preferredRsrcRprtFmt)))
    {
    FreeResourceReportId((&v->preferredRsrcRprtFmt));
    }

}  /* FreeResourceReportReq */




AsnLen
BEncResourceReportRespContent PARAMS((b, v),
BUF_TYPE b _AND_
ResourceReportResp* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (NOT_NULL((v->resourceReport)))
    {
    BEncEocIfNec(b);
    BEncEocIfNec(b);
    itemLen = BEncResourceReportContent( b, (v->resourceReport));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 8);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 51);

    totalLen += itemLen;
    }

    itemLen = BEncResourceReportRespIntContent( b, (&v->resourceReportStatus));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag2(b, CNTX, PRIM, 50);

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncResourceReportRespContent */

void
BDecResourceReportRespContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
ResourceReportResp* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 50))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecResourceReportRespIntContent( b, tagId1, elmtLen1, (&v->resourceReportStatus), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }
    else
        longjmp(env, -178);


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, CONS, 51))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        tagId2 = BDecTag(b, &totalElmtsLen1, env);

    if ( tagId2 != MAKE_TAG_ID( UNIV, CONS, EXTERNAL_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -179);
    }

    elmtLen2 = BDecLen (b, &totalElmtsLen1, env);
    (v->resourceReport) = (ResourceReport*) Asn1Alloc(sizeof(ResourceReport));
    CheckAsn1Alloc((v->resourceReport), env);
    BDecResourceReportContent( b, tagId2, elmtLen2, (v->resourceReport), &totalElmtsLen1, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -180);
    }


    if (!seqDone)
        longjmp(env, -181);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecResourceReportRespContent */

void
PrintResourceReportResp PARAMS((f, v, indent),
FILE* f _AND_
ResourceReportResp* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"resourceReportStatus ");
    PrintResourceReportRespInt(f, (&v->resourceReportStatus), indent + stdIndentG);
    if ( NOT_NULL((v->resourceReport)))
    {
    fprintf(f,",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"resourceReport ");
    PrintResourceReport(f, (v->resourceReport), indent + stdIndentG);
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintResourceReportResp */

void
FreeResourceReportResp PARAMS((v),
ResourceReportResp* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    FreeResourceReportRespInt((&v->resourceReportStatus));

    if ( NOT_NULL((v->resourceReport)))
    {
    FreeResourceReport((v->resourceReport));
    Asn1Free((v->resourceReport));
    }

}  /* FreeResourceReportResp */




AsnLen
BEncRecordsSeqOfContent PARAMS((b, v),
BUF_TYPE b _AND_
RecordsSeqOf* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

        listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    BEncEocIfNec(b);
    itemLen = BEncNamePlusRecordContent( b, component);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 16);

        listLen += itemLen;
    }
    return (listLen);

}  /* BEncRecordsSeqOfContent */

void
BDecRecordsSeqOfContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
RecordsSeqOf* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    for ( totalElmtsLen1 = 0; (totalElmtsLen1 < elmtLen0) || (elmtLen0 == INDEFINITE_LEN);)
    {
        NamePlusRecord** tmpVar;
    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ( (tagId1 == EOC_TAG_ID) && (elmtLen0 == INDEFINITE_LEN))
    {
        BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
        break; /* got EOC so can exit this SET OF/SEQ OF's for loop*/
    }
    if ( (tagId1 == MAKE_TAG_ID( UNIV, CONS, SEQ_TAG_CODE)))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    tmpVar = (NamePlusRecord**) AsnListAppend(v);
    (*tmpVar) = (NamePlusRecord*) Asn1Alloc(sizeof(NamePlusRecord));
    CheckAsn1Alloc((*tmpVar), env);
    BDecNamePlusRecordContent( b, tagId1, elmtLen1, (*tmpVar), &totalElmtsLen1, env);
    }  /* end of tag check if */
    else  /* wrong tag */
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -182);
    }
    } /* end of for */

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecRecordsSeqOfContent */

void
PrintRecordsSeqOf PARAMS((f, v, indent),
FILE* f _AND_
RecordsSeqOf* v _AND_
unsigned short int indent)
{
    NamePlusRecord* tmp;
    if (v == NULL)
        return;
    fprintf(f,"{ -- SEQUENCE OF -- \n");
    FOR_EACH_LIST_ELMT(tmp, v)
    {
        Indent(f, indent+ stdIndentG);
        PrintNamePlusRecord(f, tmp, indent + stdIndentG);
        if (tmp != (NamePlusRecord*)LAST_LIST_ELMT(v))
            fprintf(f,",\n");
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintRecordsSeqOf */

void
FreeRecordsSeqOf PARAMS((v),
RecordsSeqOf* v)
{

    AsnListNode* l;
    AsnListNode* tmp;
    if (v == NULL)
        return;
    for (l = FIRST_LIST_NODE(v); l != NULL; )
    {
        FreeNamePlusRecord((l->data));
        tmp = l->next;
        Asn1Free(l->data);
        Asn1Free(l);
        l = tmp;
    }
}  /* FreeRecordsSeqOf */




AsnLen
BEncAttributeListContent PARAMS((b, v),
BUF_TYPE b _AND_
AttributeList* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

        listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    BEncEocIfNec(b);
    itemLen = BEncAttributeElementContent( b, component);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 16);

        listLen += itemLen;
    }
    return (listLen);

}  /* BEncAttributeListContent */

void
BDecAttributeListContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
AttributeList* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    for ( totalElmtsLen1 = 0; (totalElmtsLen1 < elmtLen0) || (elmtLen0 == INDEFINITE_LEN);)
    {
        AttributeElement** tmpVar;
    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ( (tagId1 == EOC_TAG_ID) && (elmtLen0 == INDEFINITE_LEN))
    {
        BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
        break; /* got EOC so can exit this SET OF/SEQ OF's for loop*/
    }
    if ( (tagId1 == MAKE_TAG_ID( UNIV, CONS, SEQ_TAG_CODE)))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    tmpVar = (AttributeElement**) AsnListAppend(v);
    (*tmpVar) = (AttributeElement*) Asn1Alloc(sizeof(AttributeElement));
    CheckAsn1Alloc((*tmpVar), env);
    BDecAttributeElementContent( b, tagId1, elmtLen1, (*tmpVar), &totalElmtsLen1, env);
    }  /* end of tag check if */
    else  /* wrong tag */
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -183);
    }
    } /* end of for */

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecAttributeListContent */

void
PrintAttributeList PARAMS((f, v, indent),
FILE* f _AND_
AttributeList* v _AND_
unsigned short int indent)
{
    AttributeElement* tmp;
    if (v == NULL)
        return;
    fprintf(f,"{ -- SEQUENCE OF -- \n");
    FOR_EACH_LIST_ELMT(tmp, v)
    {
        Indent(f, indent+ stdIndentG);
        PrintAttributeElement(f, tmp, indent + stdIndentG);
        if (tmp != (AttributeElement*)LAST_LIST_ELMT(v))
            fprintf(f,",\n");
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintAttributeList */

void
FreeAttributeList PARAMS((v),
AttributeList* v)
{

    AsnListNode* l;
    AsnListNode* tmp;
    if (v == NULL)
        return;
    for (l = FIRST_LIST_NODE(v); l != NULL; )
    {
        FreeAttributeElement((l->data));
        tmp = l->next;
        Asn1Free(l->data);
        Asn1Free(l);
        l = tmp;
    }
}  /* FreeAttributeList */




AsnLen
BEncPresentReqContent PARAMS((b, v),
BUF_TYPE b _AND_
PresentReq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (ASNOID_PRESENT((&v->preferredRecordSyntax)))
    {
    itemLen = BEncPreferredRecordSyntaxContent( b, (&v->preferredRecordSyntax));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 104);

    totalLen += itemLen;
    }

    if (NOT_NULL((v->elementSetNames)))
    {
    BEncEocIfNec(b);
    itemLen = BEncElementSetNamesContent( b, (v->elementSetNames));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 19);

    totalLen += itemLen;
    }

    itemLen = BEncAsnIntContent( b, (&v->numRecordsRequested));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 29);

    totalLen += itemLen;

    itemLen = BEncAsnIntContent( b, (&v->resultSetStartPoint));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 30);

    totalLen += itemLen;

    itemLen = BEncResultSetIdContent( b, (&v->resultSetId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 31);

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncPresentReqContent */

