
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/*
 *    report.c
 *
 *    "REPORT" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Wed May  4 14:15:35 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */



#include "asn_incl.h"
#include "report.h"


AsnLen
BEncEstimateContent PARAMS((b, v),
BUF_TYPE b _AND_
Estimate* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    if (NOT_NULL((v->curreny_code)))
    {
    itemLen = BEncAsnIntContent( b, (v->curreny_code));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 3);

    totalLen += itemLen;
    }

    itemLen = BEncAsnIntContent( b, (&v->value));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;

    BEncEocIfNec(b);
    itemLen = BEncEstimateTypeContent( b, (&v->type));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, UNIV, PRIM, 2);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* BEncEstimateContent */

void
BDecEstimateContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
Estimate* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 1))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        tagId2 = BDecTag(b, &totalElmtsLen1, env);

    if ( tagId2 != MAKE_TAG_ID( UNIV, PRIM, INTEGER_TAG_CODE))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -100);
    }

    elmtLen2 = BDecLen (b, &totalElmtsLen1, env);
    BDecEstimateTypeContent( b, tagId2, elmtLen2, (&v->type), &totalElmtsLen1, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -101);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnIntContent( b, tagId1, elmtLen1, (&v->value), &totalElmtsLen1, env);
    if ( (elmtLen0 != INDEFINITE_LEN) && (totalElmtsLen1 == elmtLen0))
        seqDone = TRUE;
    else
    {
        tagId1 = BDecTag(b, &totalElmtsLen1, env);

         if ((elmtLen0 == INDEFINITE_LEN) && (tagId1 == EOC_TAG_ID))
        {
            BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
            seqDone = TRUE;
        }
    }
    }
    else
        longjmp(env, -102);


    if ((!seqDone) && (( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 3))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->curreny_code) = (AsnInt*) Asn1Alloc(sizeof(AsnInt));
    CheckAsn1Alloc((v->curreny_code), env);
    BDecAsnIntContent( b, tagId1, elmtLen1, (v->curreny_code), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -103);
    }


    if (!seqDone)
        longjmp(env, -104);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecEstimateContent */

void
PrintEstimate PARAMS((f, v, indent),
FILE* f _AND_
Estimate* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    fprintf(f,"type ");
    PrintEstimateType(f, (&v->type), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"value ");
    PrintAsnInt(f, (&v->value), indent + stdIndentG);
    if ( NOT_NULL((v->curreny_code)))
    {
    fprintf(f,",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"curreny-code ");
    PrintAsnInt(f, (v->curreny_code), indent + stdIndentG);
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintEstimate */

void
FreeEstimate PARAMS((v),
Estimate* v)
{

    if (v == NULL)
        return;
    FreeEstimateType((&v->type));

    FreeAsnInt((&v->value));

    if ( NOT_NULL((v->curreny_code)))
    {
    FreeAsnInt((v->curreny_code));
    Asn1Free((v->curreny_code));
    }

}  /* FreeEstimate */




AsnLen
BEncRsrcReportSeqOfContent PARAMS((b, v),
BUF_TYPE b _AND_
RsrcReportSeqOf* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

        listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    BEncEocIfNec(b);
    itemLen = BEncEstimateContent( b, component);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, CONS, 16);

        listLen += itemLen;
    }
    return (listLen);

}  /* BEncRsrcReportSeqOfContent */

void
BDecRsrcReportSeqOfContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
RsrcReportSeqOf* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    for ( totalElmtsLen1 = 0; (totalElmtsLen1 < elmtLen0) || (elmtLen0 == INDEFINITE_LEN);)
    {
        Estimate** tmpVar;
    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ( (tagId1 == EOC_TAG_ID) && (elmtLen0 == INDEFINITE_LEN))
    {
        BDEC_2ND_EOC_OCTET(b, &totalElmtsLen1, env)
        break; /* got EOC so can exit this SET OF/SEQ OF's for loop*/
    }
    if ( (tagId1 == MAKE_TAG_ID( UNIV, CONS, SEQ_TAG_CODE)))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    tmpVar = (Estimate**) AsnListAppend(v);
    (*tmpVar) = (Estimate*) Asn1Alloc(sizeof(Estimate));
    CheckAsn1Alloc((*tmpVar), env);
    BDecEstimateContent( b, tagId1, elmtLen1, (*tmpVar), &totalElmtsLen1, env);
    }  /* end of tag check if */
    else  /* wrong tag */
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -105);
    }
    } /* end of for */

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecRsrcReportSeqOfContent */

void
PrintRsrcReportSeqOf PARAMS((f, v, indent),
FILE* f _AND_
RsrcReportSeqOf* v _AND_
unsigned short int indent)
{
    Estimate* tmp;
    if (v == NULL)
        return;
    fprintf(f,"{ -- SEQUENCE OF -- \n");
    FOR_EACH_LIST_ELMT(tmp, v)
    {
        Indent(f, indent+ stdIndentG);
        PrintEstimate(f, tmp, indent + stdIndentG);
        if (tmp != (Estimate*)LAST_LIST_ELMT(v))
            fprintf(f,",\n");
    }
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintRsrcReportSeqOf */

void
FreeRsrcReportSeqOf PARAMS((v),
RsrcReportSeqOf* v)
{

    AsnListNode* l;
    AsnListNode* tmp;
    if (v == NULL)
        return;
    for (l = FIRST_LIST_NODE(v); l != NULL; )
    {
        FreeEstimate((l->data));
        tmp = l->next;
        Asn1Free(l->data);
        Asn1Free(l);
        l = tmp;
    }
}  /* FreeRsrcReportSeqOf */




AsnLen BEncRsrcReport PARAMS((b, v),
BUF_TYPE b _AND_
RsrcReport* v)
{
    AsnLen l;
    BEncEocIfNec(b);
    l = BEncRsrcReportContent(b, v);
    l += BEncConsLen(b, l);
    l += BEncTag1(b, UNIV, CONS, SEQ_TAG_CODE);
    return(l);
} /* BEncRsrcReport */

void BDecRsrcReport PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
RsrcReport* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, CONS, SEQ_TAG_CODE)))
    {
        Asn1Error("BDecRsrcReport: ERROR - wrong tag\n");
        longjmp(env, -106);
    }
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecRsrcReportContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecRsrcReport */

AsnLen
BEncRsrcReportContent PARAMS((b, v),
BUF_TYPE b _AND_
RsrcReport* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = BEncVisibleStringContent( b, (&v->message));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;

    BEncEocIfNec(b);
    itemLen = BEncRsrcReportSeqOfContent( b, (v->estimates));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* BEncRsrcReportContent */

void
BDecRsrcReportContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
RsrcReport* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 1))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->estimates) = AsnListNew(sizeof(char*));
    CheckAsn1Alloc((v->estimates), env);
    BDecRsrcReportSeqOfContent( b, tagId1, elmtLen1, (v->estimates), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -107);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecVisibleStringContent( b, tagId1, elmtLen1, (&v->message), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -108);
    }
    else
        longjmp(env, -109);


    if (!seqDone)
        longjmp(env, -110);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecRsrcReportContent */

void
PrintRsrcReport PARAMS((f, v, indent),
FILE* f _AND_
RsrcReport* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    fprintf(f,"estimates ");
    PrintRsrcReportSeqOf(f, (v->estimates), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"message ");
    PrintVisibleString(f, (&v->message), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintRsrcReport */

void
FreeRsrcReport PARAMS((v),
RsrcReport* v)
{

    if (v == NULL)
        return;
    FreeRsrcReportSeqOf((v->estimates));
    Asn1Free((v->estimates));

    FreeVisibleString((&v->message));

}  /* FreeRsrcReport */




