
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/****************************************************************************
 * UNIT: Asn1Error
 *
 * DESCRIPTION:
 *	This unit provides the ASN1 Error function to print error messages
 *	detected by the ASN1 encode/decode utilities.
 *
 * CONTENTS:
 *	Asn1Error
 *	Asn1IRAlloc
 *	Asn1IRFree
 *
 * NOTES:
 *
 * $Header$
 * $Log$
 *
/***************************************************************************/

#include <ir.h>
#include <ir_cs.h>
#include <resc.h>
#include <debug.h>


/****************************************************************************
 * FUNCTION: Asn1Error
 *
 * PURPOSE:
 *
 * INPUT:
 *	Pointer to a string.
 *
 * OUTPUT:
 *	This function returns nothing.
 *
 *
 * NOTES:
 *
 ***************************************************************************/

void Asn1PrintError(char *src, char *str)
{
	CS_LOG_PRINTV(src, "%s", str);
}
