
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/****************************************************************************
 * UNIT: IR_Debug
 *
 * DESCRIPTION:
 *	This unit provides debug functions used by the various layers in
 *	the IR application.
 *
 * CONTENTS:
 *	RescUT_DebugPrintS
 *	RescUT_DebugPrintV
 *	
 *
 * NOTES:
 *
 * $Header$
 * $Log$
 *
/***************************************************************************/

#include <ir.h>
#include <debug.h>
#include <apdu.h>


BOOLEAN		RESC_DisplayAPDU;
BOOLEAN		RescUT_LogFlag;
BOOLEAN		RescUT_LogAPDUs;

/****************************************************************************
 * FUNCTION: 
 *
 * PURPOSE:
 *
 * INPUT:
 *
 * OUTPUT:
 *
 * NOTES:
 *
 ***************************************************************************/

void RescUT_DebugInit()
{						
	unlink((char *)RESC_UT_LOG_TMP_FILE);
}

/****************************************************************************
 * FUNCTION: 
 *
 * PURPOSE:
 *
 * INPUT:
 *
 * OUTPUT:
 *
 * NOTES:
 *
 ***************************************************************************/

void RescUT_DebugPrintS(CHAR *src, CHAR *string)
{
	FILE	*fp;	

	if (RescUT_LogFlag)	
	{
		fp = fopen(RESC_UT_LOG_TMP_FILE, "a");
		if (fp != NULL)		
		{					
			fprintf(fp, "%s: %s", src, string);
			fflush(fp);		
			fclose(fp);		
		}					
	}
}

/****************************************************************************
 * FUNCTION: 
 *
 * PURPOSE:
 *
 * INPUT:
 *
 * OUTPUT:
 *
 * NOTES:
 *
 ***************************************************************************/

void RescUT_DebugPrintV(CHAR *src, CHAR *fmt, ULONG param)
{						
	FILE	*fp;			

	if (RescUT_LogFlag)				
	{						
		fp = fopen(RESC_UT_LOG_TMP_FILE, "a");
		if (fp != NULL)		
		{					
			fprintf(fp , "%s: ", src);
			fprintf(fp, fmt, param);
			fflush(fp);		
			fclose(fp);		
		}					
	}						
}

/****************************************************************************
 * FUNCTION: 
 *
 * PURPOSE:
 *
 * INPUT:
 *
 * OUTPUT:
 *
 * NOTES:
 *
 ***************************************************************************/

void RescUT_DebugTrace(CHAR *src, CHAR *string)
{						
	FILE	*fp;			

	fp = fopen(RESC_UT_LOG_TMP_FILE, "a");
	if (fp != NULL)		
	{					
		fprintf(fp, "%s: %s", src, string);
		fflush(fp);		
		fclose(fp);		
	}					
}

/****************************************************************************
 * FUNCTION: 
 *
 * PURPOSE:
 *
 * INPUT:
 *
 * OUTPUT:
 *
 * NOTES:
 *
 ***************************************************************************/


void DisplayAPDU(APDU *apdu)
{
	FILE 	*fp;

	if ((RESC_DisplayAPDU == TRUE) && (RescUT_LogFlag == TRUE))
	{
		fp = fopen(RESC_UT_LOG_TMP_FILE, "a");
		if (fp != NULL)
		{			
			PrintAPDU(fp , apdu, 2);
			fflush(fp);
			fclose(fp);
		}	
	}
}
