/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

#include <ir.h>
#include <ua.h>
#include <resc.h>
#include <resclist.h>
#include <uaep.h>
#include <string.h>

void vsToStr(char *str, VISIBLE_STRING *vs);

SHORT UaArc_CreateInfoDlg(WINDOW win, UAEP_DIALOG *info)
{
	WINDOW	ctlWin;
	IRO_ASSOC_FULL_INFO_STRUCT infoStruct;
	CHAR	tmpBuf[200];
	static SHORT	testm=0;

	/* Get the related information for the select association */
	memset(&infoStruct, 0, sizeof(IRO_ASSOC_FULL_INFO_STRUCT));
	RESC_ASN_NO_MALLOC(&infoStruct);

	if (UaAc_GetAssociationInfoFull(info->data.arcStatus.assocId,
	    &infoStruct) == IR_FAIL)
	{
		info->data.arcStatus.assocId = IR_UNKNOWN_ID_TYPE;
		return(-1);
	}

	/* 
	 * Use the info struct to determine which control buttons
 	 * are valid for this association.
	 */
	switch(infoStruct.assocStruct.state)
	{
	case IRO_ASSOC_STATE_SEARCH:
		strcpy(tmpBuf, "Search");
		break;
	case IRO_ASSOC_STATE_PRESENT:
		strcpy(tmpBuf, "Fetch");
		break;
	case IRO_ASSOC_STATE_DELETE:
		strcpy(tmpBuf, "Delete");
		break;
	case IRO_ASSOC_STATE_INIT:
		strcpy(tmpBuf, "Init");
		break;
	case IRO_ASSOC_STATE_CONNECT:
		strcpy(tmpBuf, "Connect");
		break;
	case IRO_ASSOC_STATE_RSRC_RPRT:
		strcpy(tmpBuf, "Rsrc Rprt");
		break;

	case IRO_ASSOC_STATE_IDLE:
		strcpy(tmpBuf, "Idle");
		break;
	default:
		strcpy(tmpBuf, "Unknown");
		break;
	}

	ctlWin = get_ctl_window(win, DLG_AI_CUR_STATE_DISP);
	set_title(ctlWin, tmpBuf);

	ctlWin = get_ctl_window(win, DLG_AI_PMS_DISP);
	sprintf(tmpBuf, "%ld", infoStruct.initResp.preferredMessageSize);
	set_title(ctlWin, tmpBuf);

	ctlWin = get_ctl_window(win, DLG_AI_MRS_DISP);
	sprintf(tmpBuf, "%ld", infoStruct.initResp.maximumRecordSize);
	set_title(ctlWin, tmpBuf);

	ctlWin = get_ctl_window(win, DLG_AI_SEARCH_BOX);
	win_check_box(ctlWin, infoStruct.initResp.search);

	ctlWin = get_ctl_window(win, DLG_AI_PRESENT_BOX);
	win_check_box(ctlWin, infoStruct.initResp.present);

	ctlWin = get_ctl_window(win, DLG_AI_DELETE_BOX);
	win_check_box(ctlWin, infoStruct.initResp.delSet);

	ctlWin = get_ctl_window(win, DLG_AI_RSRC_RPRT_BOX);
	win_check_box(ctlWin, infoStruct.initResp.resourceReport);

	ctlWin = get_ctl_window(win, DLG_AI_TRIG_CTRL_BOX);
	win_check_box(ctlWin, infoStruct.initResp.triggerResourceCtrl);

	ctlWin = get_ctl_window(win, DLG_AI_ACCESS_CTRL_BOX);
	win_check_box(ctlWin, infoStruct.initResp.accessCtrl);

	ctlWin = get_ctl_window(win, DLG_AI_RSRC_CTRL_BOX);
	win_check_box(ctlWin, infoStruct.initResp.resourceCtrl);

	ctlWin = get_ctl_window(win, DLG_AI_LOCAL_NAME_EDIT);
	vsToStr(tmpBuf, &infoStruct.assocStruct.name);
	set_title(ctlWin, tmpBuf);

	ctlWin = get_ctl_window(win, DLG_AI_IMP_NAME_EDIT);
	vsToStr(tmpBuf, &infoStruct.initResp.implementationName);
	set_title(ctlWin, tmpBuf);

	ctlWin = get_ctl_window(win, DLG_AI_IMP_VERSION_EDIT);
	vsToStr(tmpBuf, &infoStruct.initResp.implementationVersion);
	set_title(ctlWin, tmpBuf);


	ctlWin = get_ctl_window(win, DLG_AI_IMP_ID_EDIT);
	vsToStr(tmpBuf, &infoStruct.initResp.implementationId);
	set_title(ctlWin, tmpBuf);

	ctlWin = get_ctl_window(win, DLG_AI_PROTOCOL_VER_EDIT);
	vsToStr(tmpBuf, &infoStruct.initResp.protocolVersion);
	set_title(ctlWin, tmpBuf);
	
	ctlWin = get_ctl_window(win, DLG_AI_USER_INFO_EDIT);
	vsToStr(tmpBuf, &infoStruct.initResp.userInfo);
	set_title(ctlWin, tmpBuf);
	RescUT_DebugVS(IR_FILE, &infoStruct.initResp.userInfo);

	UaAc_DestroyFullInfoStruct(&infoStruct);
	return(0);
}

#define MAX_STR	100

void vsToStr(char *str, VISIBLE_STRING *vs)
{
	/* Assume str can hold all of vs */

	if (vs->len == 0)
	{
		strcpy(str, "");
	}
	else
	{
		if (vs->len > MAX_STR)
		{
			strncpy(str, vs->sPtr, MAX_STR);
			str[MAX_STR] = (CHAR)NULL;
		}
		else
		{
			strncpy(str, vs->sPtr, vs->len);
			str[vs->len] = (CHAR)NULL;
		}

	}
}
