/*
	This file was generated by XVT-Design 2.0, a product of:

		XVT Software Inc.
		4900 Pearl East Circle
		Boulder, CO USA 80301
		303-443-4223, fax 303-443-0969

	Generated on Wed May 11 09:27:47 1994
*/

#include "xvt.h"
#include "uaep.h"

/* 
	Information about the dialog
*/
#define DLG_RES_ID DLG_SEARCH_DATABASE
#define DLG_FLAGS 0x0L
#define DLG_CLASS ""
#define DLG_MODE WD_MODAL
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 ************************************************************************/
#include <resc.h>
#include <resclist.h>
static SLIST targetList=(SLIST)NULL;
static SLIST *dbNameList=(SLIST *)NULL;
/*
	Handler for dialog DLG_SEARCH_DATABASE ("Database Selection")
*/
long
#if XVT_CC_PROTO
dlg_107_eh(WINDOW xdWindow, EVENT *xdEvent)
#else
dlg_107_eh(xdWindow, xdEvent)
WINDOW xdWindow;
EVENT *xdEvent;
#endif
{
	short xdControlId = xdEvent->v.ctl.id;
	UAEP_DIALOG	*info;
	switch (xdEvent->type) {
	case E_CREATE:
		/*
			Dialog has been created; first event sent to newly-created
			dialog.
		*/
		{
		if (!targetList)
		{
			targetList = slist_new();
		}
		if (UaSc_DbInitDlg(xdWindow, targetList, &dbNameList) == IR_FAIL)
		{
			close_window(xdWindow);
		}
		}
		break;
	case E_DESTROY:
		/*
			Dialog has been closed; last event sent to dialog.
		*/
		{
		if (targetList)
		{
			slist_dispose(targetList);
			targetList = (SLIST)NULL;
		}
		UaSc_DbDestroyDlg(xdWindow, dbNameList);
		/* Reset the database name List */
		dbNameList = (SLIST *)NULL;
		
		}
		break;
	case E_FOCUS:
		{
		/*
			Dialog has lost or gained focus.
		*/
		if (xdEvent->v.active)  {
			/*
				Dialog has gained focus
			*/
		} else {
			/*
				Dialog has lost focus
			*/
		}
		}
		break;
	case E_SIZE:
		/*
			Size of dialog has been set or changed; sent when dialog is
			created or subsequently resized by move_window.
		*/
		{
		}
		break;
	case E_CLOSE:
		/*
			Request to close dialog; user operated "close" menu item on
			dialog system menu, or operated "close" control on dialog
			frame. Dialog not closed unless close_window is called.
		*/
		{
		close_window(xdWindow);
		}
		break;
	case E_CHAR:
		/*
			Character typed.
		*/
		{
		}
		break;
	case E_CONTROL:
		/*
			User operated control in dialog.
		*/
		
		info = (UAEP_DIALOG *)get_app_data(xdWindow);
		switch(xdControlId) {
		case SD_OK: /* "OK" */
			{
			info->cancelled = FALSE;
			UaSc_DbGetDatabases(xdWindow, info, targetList, dbNameList);
			if (RESC_LIST_SIZE(&info->data.database.dbNameList) == 0)
			{
				/* The user did not select any databases */
				xvt_beep();
			}
			else
			{
				close_window(xdWindow);
			}
			}
			break;
		case SD_CANCEL: /* "Cancel" */
			{
			info->cancelled =TRUE;
			close_window(xdWindow);
			}
			break;
		case SD_TARGET_LB:			{
			UaSc_DbHandleTargetList(xdWindow, targetList, dbNameList);
			}
			break;
		case SD_DATABASE_LIST:			{
			/*
				List box was operated.
			*/
			if (xdEvent->v.ctl.ci.v.lbox.dbl_click) {
				/*
					double click
				*/
			} else {
				/*
					single click
				*/
			}
			}
			break;
		case SD_ADV_OPTIONS_BUTTON: /* "Options" */
			{
			UaSc_DbOptionsButton(xdWindow, info);
			}
			break;
		case SD_SEND: /* "Send" */
			{
			info->data.database.search = TRUE;
			/* The following code is the same for  selection of the OK button */
			info->cancelled = FALSE;
			UaSc_DbGetDatabases(xdWindow, info, targetList, dbNameList);
			if (RESC_LIST_SIZE(&info->data.database.dbNameList) == 0)
			{
				/* The user did not select any databases */
				xvt_beep();
			}
			else
			{
				close_window(xdWindow);
			}
			}
			break;
		default:
			xvt_error("Unrecognized control in \"DLG_SEARCH_DATABASE\"");
			break;
		}
		break;
	case E_TIMER:
		/*
			Timer associated with window went off.
		*/
		{
		}
		break;
	case E_USER:
		/*
			Application initiated.
		*/
		{
		switch (xdEvent->v.user.id) {
		case -1:
		default:
			xvt_note("unknown user event");
			break;
		}
		}
		break;
	default:
		break;
	}
	return 0L;
}
