/*
	This file was generated by XVT-Design 2.0, a product of:

		XVT Software Inc.
		4900 Pearl East Circle
		Boulder, CO USA 80301
		303-443-4223, fax 303-443-0969

	Generated on Wed May 11 09:27:38 1994
*/

#include "xvt.h"
#include "uaep.h"

static long task_eh XVT_CC_ARGS((WINDOW xdWindow, EVENT *xdEvent));
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 ************************************************************************/
long UpdateTimer;
XVT_CONFIG xvt_config = {
	MAIN_MENUBAR, /* task window menu bar ResID */
	0, /* default aboutbox ResID */
	"uaep", /* application's "file name" */
	"IR Origin", /* application's name */
	"CANSEARCH" /* title for task window */
};

int
#if XVT_CC_PROTO
main(int argc, char *argv[])
#else
main(argc, argv)
int argc;
char *argv[];
#endif
{
#if (XVTWS == MTFWS)
	set_value (NULL_WIN, ATTR_XM_PLACE_WINDOW_EXACT, (long)TRUE);
#endif
#if (XVTWS == XOLWS)
	set_value (NULL_WIN, ATTR_XOL_PLACE_WINDOW_EXACT, (long)TRUE);
#endif
if (UaEp_Initialize(argc, argv) == 0 )
{
	xvt_system(argc, argv, 0L, task_eh, &xvt_config);
}
return 0;}

static long
#if XVT_CC_PROTO
task_eh(WINDOW xdWindow, EVENT *xdEvent)
#else
task_eh(xdWindow, xdEvent)
WINDOW xdWindow;
EVENT *xdEvent;
#endif
{
	static UAEP_DIALOG	loginData;
	static UAEP_DIALOG	dlgRqst;
	switch (xdEvent->type) {
	case E_CREATE:
		{
			int i, j;
			MENU_ITEM *menu;

			menu = win_menu_fetch(xdWindow);
			for (i = 0; menu[i].tag != 0; i++ ) {
				if (menu[i].tag == M_FILE || menu[i].tag == M_EDIT) {
					for (j = 0; menu[i].child[j].tag != 0; j++ ) {
						win_menu_enable(xdWindow, menu[i].child[j].tag, TRUE);
					}
				}
			}
		}

		/*
			Task window has been created; first event sent to application.
		*/
		{
		/*
		 * Initialize the IR origin API.
		 */
		if (UaEp_InitIRApi() != 0)
		{
			xvt_note("Could not initialize IR api");
		}
		/*
		 * Get the user Name and password.
		 */
		memset(&loginData, (CHAR)NULL, sizeof(UAEP_DIALOG));
		if (!create_res_dialog(WD_MODAL, DLG_MAIN_LOGIN, 
		    EM_ALL, dlg_104_eh, (long)&loginData))
		{
			xvt_error("Can't open Login dialog");
		}
		else
		{
			UaEp_InitTaskWin(&loginData);
			UpdateTimer = set_timer(TASK_WIN, 1000L);
		  	memset(&dlgRqst, (CHAR)NULL, sizeof(UAEP_DIALOG));
			dlgRqst.cancelled = FALSE;
			if (!create_res_dialog(WD_MODAL, DLG_CONNECT_MAKE, 
			    EM_ALL, dlg_101_eh, (long)&dlgRqst))
				xvt_error("Can't open dialog");
			if (dlgRqst.cancelled == FALSE)
			{
				UaAc_MakeAssociation(&dlgRqst);
			}
		}
		}
		break;
	case E_DESTROY:
		/*
			Application is being terminated; last event sent to application.
		*/
		break;
	case E_SIZE:
		/*
			Size of task window has been set or changed. Always sent
			on application startup; may be sent subsequently if
			physical task window (Win/PM) is resized by user or via
			move_window.
		*/
		break;
	case E_CLOSE:
		/*
			Request to close (terminate) application; user operated
			"close" menu item on task or ghost window system menu, or
			operated "close" control on task or ghost window frame.
			Possible if physical task window or on X-based systems. Not
			sent if Close on File menu is issued.
		*/
		{
		if (is_quit_OK())
		{
			if (UaEp_Terminate())
			{
				UaSc_DestroyQueryHist();
				xvt_terminate();
			}
		}
		}
		break;
	case E_COMMAND:
		/*
			User issued command on TASK_WIN menu bar. Platform specifics: 
			Win/PM -- no MDI docs open and task-window menu bar operated; 
			X* -- no docs open and ghost window menu bar operated; 
			Mac/CH -- no docs have focus; menu bar at top of screen operated.
		*/
		{
		do_MAIN_MENUBAR(xdWindow, xdEvent);
		}
		break;
	case E_FONT:
		/*
			User issued font command on window menu bar (menu bar at top of
			screen for Mac/CH).
		*/
		break;
	case E_TIMER:
		/*
			Timer associated with TASK_WIN went off.
		*/
		{
		UaEp_Timer(xdWindow, xdEvent);
		
		if (xdEvent->v.timer.id == UpdateTimer)
		{
			UaAc_CheckTimeout();
		}
		}
		break;
	case E_QUIT:
		/*
			System shutdown. (Sent only on those platforms which
			provide this information to XVT.)
		*/
		{
		if (xdEvent->v.query) {
			if (is_quit_OK())
				quit_OK();
		} else
			xvt_terminate();
		}
		break;
	case E_USER:
		/*
			Application initiated.
		*/
		{
		switch (xdEvent->v.user.id) 
		{
		case 1:
			UaEp_CommEvent(xdWindow, xdEvent);
			break;
		case -1:
		default:
			xvt_note("unknown user event");
			break;
		}
		}
		break;
	}
	return 0L;
}

BOOLEAN
#if XVT_CC_PROTO
is_quit_OK(void)
#else
is_quit_OK()
#endif
{
	return TRUE;
}

void
#if XVT_CC_PROTO
CheckRadioButton(WINDOW xdWindow, int check, int start, int end)
#else
CheckRadioButton(xdWindow, check, start, end)
WINDOW xdWindow;
int check;
int start;
int end;
#endif
{
	WINDOW *radiobtns;
	int num_btns = end - start + 1;
	int i;
	radiobtns = (WINDOW *)xvt_malloc(num_btns * sizeof(WINDOW));
	for (i = start; i <= end; i++) {
		radiobtns[i-start] = get_ctl_window(xdWindow, i);
	}
	win_check_radio_button(get_ctl_window(xdWindow, check), radiobtns, 
		num_btns);
	xvt_free((char *)radiobtns);
}

