/*
	This file was generated by XVT-Design 2.0, a product of:

		XVT Software Inc.
		4900 Pearl East Circle
		Boulder, CO USA 80301
		303-443-4223, fax 303-443-0969

	Generated on Wed May 11 09:27:44 1994
*/

#include "xvt.h"
#include "uaep.h"

/* 
	Information about the window
*/
#define WIN_RES_ID WIN_WORKSPACE
#define WIN_FLAGS 0x180dL
#define WIN_CLASS ""
#define WIN_BORDER W_DOC
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 ************************************************************************/
UAEP_WINDOW  *UaEp_GetWinInfo(WINDOW);
void UaEp_CalcDimensions(WINDOW);
void UaEp_ScrollSync(WINDOW);
void UaEp_DeleteWs(UAEP_WINDOW *);
void UaEp_DoUpdate(WINDOW, RCT);
void UaEp_DoScroll(WINDOW, SCROLL_TYPE, SCROLL_CONTROL, short);
/*
	Handler for window WIN_WORKSPACE ("workspace")
*/
long
#if XVT_CC_PROTO
win_501_eh(WINDOW xdWindow, EVENT *xdEvent)
#else
win_501_eh(xdWindow, xdEvent)
WINDOW xdWindow;
EVENT *xdEvent;
#endif
{
	short xdControlId = xdEvent->v.ctl.id;
	UAEP_WINDOW *info;
	RCT rct;
	info = UaEp_GetWinInfo(xdWindow);
	switch (xdEvent->type) {
	case E_CREATE:
		/*
			Window has been created; first event sent to newly-created
			window.
		*/
		{
		UaEp_CalcDimensions(xdWindow);
		UaEp_ScrollSync(xdWindow);
		}
		break;
	case E_DESTROY:
		/*
			Window has been closed; last event sent to window.
		*/
		{
		UaEp_DeleteWs(info);
		}
		break;
	case E_FOCUS:
		{
		/*
			Window has lost or gained focus.
		*/
		if (xdEvent->v.active)  {
			/*
				Window has gained focus
			*/
		} else {
			/*
				Window has lost focus
			*/
		}
		}
		break;
	case E_SIZE:
		/*
			Size of window has been set or changed; sent when window is
			created or subsequently resized by user or via move_window.
		*/
		{
		UaEp_ScrollSync(xdWindow);
		invalidate_rect(xdWindow, NULL);
		}
		break;
	case E_UPDATE:
		/*
			Window requires updating.
		*/
		{
		get_client_rect(xdWindow, &rct);
		UaEp_DoUpdate(xdWindow, rct);
		}
		break;
	case E_CLOSE:
		/*
			Request to close window; user operated "close" menu item on
			window system menu, or operated "close" control on window
			frame. Not sent if Close on File menu is issued. Window not
			closed unless close_window is called.
		*/
		{
		close_window(xdWindow);
		}
		break;
	case E_CHAR:
		/*
			Character typed.
		*/
		{
		}
		break;
	case E_MOUSE_UP:
		/*
			Mouse was released
		*/
		{
		}
		break;
	case E_MOUSE_DOWN:
		/*
			Mouse was pressed
		*/
		{
		}
		break;
	case E_MOUSE_DBL:
		/*
			Mouse was double clicked
		*/
		{
		get_client_rect(xdWindow, &rct);
		UaEp_MouseDouble(xdWindow, rct, xdEvent->v.mouse.where);
		}
		break;
	case E_MOUSE_MOVE:
		/*
			Mouse was moved
		*/
		{
		}
		break;
	case E_HSCROLL:
		{
		/*
			Horizontal scrollbar on frame was operated
		*/
		UaEp_DoScroll(xdWindow, HSCROLL, xdEvent->v.scroll.what,
		    xdEvent->v.scroll.pos);
		}
		break;
	case E_VSCROLL:
		{
		/*
			Vertical scrollbar on frame was operated
		*/
		UaEp_DoScroll(xdWindow, VSCROLL, xdEvent->v.scroll.what,
		    xdEvent->v.scroll.pos);
		}
		break;
	case E_COMMAND:
		/*
			User issued command on window menu bar (menu bar at top of
			screen for Mac/CH).
		*/
		{
		/*
			No menubar was associated with this window
		*/
		}
		break;
	case E_CONTROL:
		/*
			User operated control in window.
		*/
		switch(xdEvent->v.ctl.id)
		{
		case -1:
		default:
			xvt_error("Unrecognized control in \"WIN_WORKSPACE\"");
		}
		switch(xdControlId) {
		case -1:
		default:
			xvt_error("Unrecognized control in \"WIN_WORKSPACE\"");
			break;
		}
		break;
	case E_FONT:
		/*
			User issued font command on window menu bar (menu bar at top of
			screen for Mac/CH).
		*/
		{
		win_set_font_menu(xdWindow, &xdEvent->v.font.font);
		info->font = xdEvent->v.font.font;
		UaEp_CalcDimensions(xdWindow);
		UaEp_ScrollSync(xdWindow);
		invalidate_rect(xdWindow, NULL);
		}
		break;
	case E_TIMER:
		/*
			Timer associated with window went off.
		*/
		{
		}
		break;
	case E_USER:
		/*
			Application initiated.
		*/
		{
		switch (xdEvent->v.user.id) {
		case -1:
		default:
			xvt_note("unknown user event");
			break;
		}
		}
		break;
	default:
		break;
	}
	tx_event(xdWindow, xdEvent);
	return 0L;
}
